-rw-r--r-- | delta.jscad | 44 |
1 files changed, 43 insertions, 1 deletions
diff --git a/delta.jscad b/delta.jscad index b718fd4..fa33a0d 100644 --- a/delta.jscad +++ b/delta.jscad @@ -28,12 +28,20 @@ var CONFIG = { }, duet: { pcb_size: { x: 124, y: 100, z: 1 }, hole_spacing: { x: 115, y: 92 }, h: 30 }, + foot: { + d: 20*Math.sqrt(2), h: 30, + bolt: { d:5, l: 19, hd: 10 }, + margin: 2.5, + nut: { d: 8.6 /* TODO: */, h: 3.5 }, + shell: 4, + zscalefactor: 1.6 + }, hotend: { h: 62.4, // full assembly height groove: { d:12, h:6 }, // grove diameter and height ungroove: { d:16, above:3.7, below: 3+4 } }, effector: { @@ -79,13 +87,14 @@ var CONFIG = { } }, nut: { h: 2.3, w: 5.5 }, color: { extrusion: [0.8, 0.8, 0.8, 0.8], pcb: [ 0, 0.3, 0.2, 0.8 ], - bulk: [ .9, .9, .9, .2 ] + bulk: [ .9, .9, .9, .2 ], + parts: [ 0, 0.8, 0, 0.9 ] } }; var CD = { base: (function(){ var rv = {}; @@ -581,12 +590,44 @@ function duet() { rv.properties.holes = pholes; rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); rv.properties.vitamin = true; return rv; } +function foot() { + var F = CONFIG.foot; + var br = F.bolt.hd/2+F.margin; + var bh = F.zscalefactor*Math.sqrt(Math.pow(F.d/2,2)-Math.pow(br,2)); + var th = F.h-bh; + var r = 2*F.d; + var rv = CSG.sphere({ // botom contorted sphere + center: [0,0,0], radius: F.d/2, resolution: r + }).scale([1,1,F.zscalefactor]).translate([0,0,bh]).union(CSG.cylinder({ // top hat + start: [0,0,bh], end: [0,0,F.h], radius: F.d/2, resolution: r + })).intersect(CSG.cylinder({ // cut off excess + start: [0,0,0], end: [0,0,F.h], radius: F.d + })).subtract([ + CSG.cylinder({ // bolt hole + start: [0,0,-1], end: [0,0,F.h+1], radius: F.bolt.d/2+PRINT.slide_tolerance + }), CSG.cylinder({ // nut hole + start: [0,0,F.h-F.nut.h-PRINT.play_tolerance], + end: [0,0,F.h], + radius: F.nut.d/2+PRINT.slide_tolerance, resolution: 6 + }), CSG.cylinder({ // bolthead/washer hole + start: [0,0,-1], end: [0,0,F.h-F.nut.h-PRINT.play_tolerance-F.shell], + radius: F.bolt.hd/2+PRINT.play_tolerance + }) + ]).union(CSG.cylinder({ // bridging patch + start: [0,0,F.h-F.nut.h-PRINT.play_tolerance-PRINT.layer_height], + end: [0,0,F.h-F.nut.h-PRINT.play_tolerance], + radius: F.nut.d/2 + })); + rv.properties.P = new CSG.Connector([0,0,F.h],[0,0,-1],[1,0,0]); + return rv.setColor(CONFIG.color.parts); +} + function refaxes(o) { if(!o) o = {}; var l = o.l||20, g = o.g||0.7; return union([ CSG.cylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]), CSG.cylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]), @@ -597,12 +638,13 @@ function refaxes(o) { function P(x) { return x.connectTo(x.properties.P,new CSG.Connector([0,0,0],[0,0,1],[1,0,0]), false, 0); } var PARTS = { wip: function(params) { + return foot(); return union(base_extrusions(),column_extrusions(),duet()); } }; function main(params) { var part = params.part && PARTS[params.part]; |